// -*-C++-*-

#include <string>

class ShuffleList
{
public:

  ShuffleList (unsigned pWordSize, unsigned pWordCount);

  ~ShuffleList ();

  void AddOperation (unsigned *Variation);

  void Calculate ();

  unsigned Apply (unsigned Op, unsigned S1, unsigned S2);

  unsigned GetOpOfVar (unsigned V) { return Operation[V]; }
  unsigned GetArg1 (unsigned V) { return Source1[V]; }
  unsigned GetArg2 (unsigned V) { return Source2[V]; }
  unsigned GetDepth (unsigned V) { return Depth[V]; }

  unsigned GetWordSize () { return WordSize; }

  void Print ();
  void PrintVariation (unsigned VI);
  void PrintOperation (unsigned O);

  void Query (unsigned *V) { Query (Variation2Index (V)); }
  void Query (unsigned V);

  unsigned Variation2Index (unsigned *Variation);
  void Index2Variation (unsigned Index, unsigned *Variation);

private:

  unsigned WordSize;
  unsigned WordCount;
  unsigned ElementCount;
  unsigned VariationCount;

  unsigned *Source1;
  unsigned *Source2;
  unsigned *Operation;
  unsigned *Depth;

  unsigned *Elements;

  unsigned PrimitiveCount;
  unsigned *Primitive;

  unsigned *ReV;
};
